Bug 3874 - Segmentation fault в XMMS 1.2.10
: Segmentation fault в XMMS 1.2.10
Status: CLOSED FIXED
: Sisyphus
(All bugs in Sisyphus/xmms)
: unstable
: all Linux
: P2 blocker
Assigned To:
:
:
:
:
:
  Show dependency tree
 
Reported: 2004-03-25 09:49 by
Modified: 2006-02-17 15:31 (History)


Attachments
Результат вывода strace. (30.57 KB, text/plain)
2004-03-25 09:50, Michael Bochkaryov
no flags Details
Результат вывода strace -ff (31.78 KB, text/plain)
2004-03-25 10:20, Michael Bochkaryov
no flags Details
Worked conf (3.82 KB, text/plain)
2005-02-21 15:20, Andy Gorev
no flags Details


Note

You need to log in before you can comment on or make changes to this bug.


Description From 2004-03-25 09:49:41
При запуске XMMS 1.2.10 выдает:
-------------------------------------------------------
Segmentation fault

You've probably found a bug in XMMS, please visit
http://bugs.xmms.org and fill out a bug report.

-------------------------------------------------------
Установлено:
xmms-1.2.10-alt2
xmms-out-alsa-1.2.10-alt2
libalsa-1.0.3b-alt1
kernel-modules-alsa-std-up-0.9.8-alt5.15

-------------------------------------------------------


Steps to Reproduce:
1. Запуск XMMS
2.
3.
------- Comment #1 From 2004-03-25 09:50:35 -------
Created an attachment (id=362) [details]
Результат вывода strace.

Может, поможет чем-то.
------- Comment #2 From 2004-03-25 09:59:53 -------
Можно strace -ff?

Воспроизводится ли при отодвинутом в сторону ~/.xmms? (его бы заархивировать,
кстати)
------- Comment #3 From 2004-03-25 10:18:02 -------
Какой-такой .xmms ?
Нет его у меня.
------- Comment #4 From 2004-03-25 10:20:57 -------
Created an attachment (id=363) [details]
Результат вывода strace -ff
------- Comment #5 From 2004-03-25 10:22:54 -------
Ну, ~/.xmms.  Как это нету?  Мы успеваем сегфолтнуться до того, как его mkdir?
=8-O
------- Comment #6 From 2004-03-25 10:42:09 -------
Отловил глюк, похоже. Не хватало ему .xmms у юзера.
Полечилось таким действием:

cp -rpv /root/.xmms /home/misha/.xmms
chown -R misha /home/misha/.xmms
------- Comment #7 From 2004-03-25 14:32:45 -------
Ой.  Ойой.  Понимаешь, тест "голого" xmms без ~/.xmms -- базовый и прогоняется
для  каждой новой сборки.
------- Comment #8 From 2004-03-25 14:36:29 -------
Заходи.
Я даже .xmms готов ради тебя грохнуть :)
------- Comment #9 From 2004-03-25 14:39:49 -------
Лучше отодвинуть/затарить тот, с которым плохо.  Вот если _без_ ~/.xxms
взрывается... Чесслово, первый раз вижу (с 0.7).
------- Comment #10 From 2004-03-25 14:42:51 -------
misha@rattler ~ $ mv .xmms .xmms_
misha@rattler ~ $ xmms

Нарушение сегментации!

Скорее всего вы наткнулись на ошибку в XMMS. Пожалуйста, посетите
http://bugs.xmms.org и отправьте сообщение об ошибке.
------- Comment #11 From 2004-10-20 19:36:55 -------
Упс.  До сих пор не исправлено.

Могу по крайней мере порекомендовать запускать из 
меню, там создаётся некоторый изначальный конфиг (см.
/usr/share/xmms/xmms-wrapper.sh).
------- Comment #12 From 2004-10-20 19:38:47 -------
btw, it's a blocker
------- Comment #13 From 2004-11-05 22:51:21 -------
*** Bug 5451 has been marked as a duplicate of this bug. ***
------- Comment #14 From 2005-02-21 15:20:53 -------
Created an attachment (id=750) [details]
Worked conf
------- Comment #15 From 2005-03-11 13:33:54 -------
без  .xmms (или с испорченным .xmms/config):  
strace ничего хорошего не показывает. дебаггером вычислил что он уже сделал - 
dlopen arts.   интуиция подсказала снести нафиг arts  --nodeps  - получил все ОК. 
когда после первого запуска создается конфиг, arts можно вернуть на место.   
(кстати, автотесты проходят - видимо там артса нет, он же динамически  
линкуется).  
если оторвать arts от автоугадава?  
  
------- Comment #16 From 2005-03-11 13:37:59 -------
Значит, так и сделаем -- давно собирался.  Всё равно у нас soundwrapper для
этого предназначен.

Буду признателен за NMU, и можно xmms класть в xmms-bin какой, а
/usr/share/xmms/xmms-wrapper.sh класть в /usr/bin/xmms, чтоб проблему запуска
из
консоли решить. (или проблемы-то и нет? :)
------- Comment #17 From 2005-03-11 13:42:59 -------
*** Bug 5730 has been marked as a duplicate of this bug. ***
------- Comment #18 From 2005-03-27 17:38:13 -------
Кажется, починил -- ждите 1.2.10-alt4.

PS: блин... однострочный фикс делать полгода... и никто не подстраховал. 
Значит, так он и нужен в наши дни, xmms.
------- Comment #19 From 2005-03-27 17:43:08 -------
Я тебе полтора месяца назад хак присылал.
------- Comment #20 From 2005-03-27 18:22:11 -------
Да дело-то не в хаке, а в том, что бага год провисела, пока у меня руки до xmms
дошли.  И всем, в общем-то, это было пофиг.

Другое дело, что в этой сборке учтена ещё пара предложений, пока так:

* Sun Mar 27 2005 Michael Shigorin <mike@altlinux.ru> 20050327:1.2.10-alt4
- removed patch55 (ARTS autodetection -- done with soundwrapper anyways)
- small shuffle: /usr/bin/xmms is now wrapper with binary in xmms-bin
  (should fix "first run from console results in krakozabras" trouble)
- added small check to wrapper (should fix "segfault on start")
- merged some PLD patches (divzero in diskwriter, alsa-mono-vol-adjust)
- merged some Dag's patches (autoconf 1.8 "underquoted" plus for TODO)

...ну и с текущими automake/aclocal оно всё равно не собиралось.
------- Comment #21 From 2005-03-27 21:07:00 -------
(In reply to comment #20)
> Да дело-то не в хаке, а в том, что бага год провисела, пока у меня руки до xmms
> дошли.  И всем, в общем-то, это было пофиг.
> 
> Другое дело, что в этой сборке учтена ещё пара предложений, пока так:

Не забудь эту бажку:

https://bugzilla.altlinux.org/show_bug.cgi?id=6008

:)
------- Comment #22 From 2005-04-11 17:35:53 -------
Тааак... похоже, не зня не торопился.

Господа, а alt4 у меня на кириллице в плейлистах валится.  Дословно:

[pid  4955] open("/home/mike/.xmms/xmms.m3u", O_RDONLY) = 9
[pid  4955] fstat64(9, {st_mode=S_IFREG|0644, st_size=82, ...}) = 0
[pid  4955] mmap2(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS,
-1, 0) = 0xb757b000
[pid  4955] read(9,
"/home/mike/mp3/\360_\313\313\301\322\304_\312\323\330\313"..., 4096) = 82
[pid  4955] brk(0)                      = 0x81f5000
[pid  4955] brk(0x8218000)              = 0x8218000
[pid  4955] open("/usr/lib/gconv/CP1251.so", O_RDONLY) = 10
[pid  4955] read(10,
"\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0\20\4\0"..., 512) = 512
[pid  4955] fstat64(10, {st_mode=S_IFREG|0644, st_size=9352, ...}) = 0
[pid  4955] mmap2(NULL, 12316, PROT_READ|PROT_EXEC, MAP_PRIVATE|MAP_DENYWRITE,
10, 0) = 0xb7577000
[pid  4955] mmap2(0xb7579000, 8192, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_FIXED|MAP_DENYWRITE, 10, 0x1) = 0xb7579000
[pid  4955] close(10)                   = 0
[pid  4955] brk(0)                      = 0x8218000
[pid  4955] brk(0x8240000)              = 0x8240000
[pid  4955] open("/usr/lib/gconv/KOI8-R.so", O_RDONLY) = 10
[pid  4955] read(10,
"\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0\20\4\0"..., 512) = 512
[pid  4955] fstat64(10, {st_mode=S_IFREG|0644, st_size=9352, ...}) = 0
[pid  4955] mmap2(NULL, 12316, PROT_READ|PROT_EXEC, MAP_PRIVATE|MAP_DENYWRITE,
10, 0) = 0xb7573000
[pid  4955] mmap2(0xb7575000, 8192, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_FIXED|MAP_DENYWRITE, 10, 0x1) = 0xb7575000
[pid  4955] close(10)                   = 0
[pid  4955] brk(0)                      = 0x8240000
[pid  4955] brk(0x8268000)              = 0x8268000
[pid  4955] open("/usr/lib/gconv/IBM866.so", O_RDONLY) = 10
[pid  4955] read(10,
"\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0\20\4\0"..., 512) = 512
[pid  4955] fstat64(10, {st_mode=S_IFREG|0644, st_size=9352, ...}) = 0
[pid  4955] mmap2(NULL, 12316, PROT_READ|PROT_EXEC, MAP_PRIVATE|MAP_DENYWRITE,
10, 0) = 0xb756f000
[pid  4955] mmap2(0xb7571000, 8192, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_FIXED|MAP_DENYWRITE, 10, 0x1) = 0xb7571000
[pid  4955] close(10)                   = 0
[pid  4955] brk(0)                      = 0x8268000
[pid  4955] brk(0x8289000)[pid  4955] open("/home/mike/.xmms/xmms.m3u",
O_RDONLY) = 9
[pid  4955] fstat64(9, {st_mode=S_IFREG|0644, st_size=82, ...}) = 0
[pid  4955] mmap2(NULL, 4096, PROT_READ|PROT_WRITE, MAP_PRIVATE|MAP_ANONYMOUS,
-1, 0) = 0xb757b000
[pid  4955] read(9,
"/home/mike/mp3/\360_\313\313\301\322\304_\312\323\330\313"..., 4096) = 82
[pid  4955] brk(0)                      = 0x81f5000
[pid  4955] brk(0x8218000)              = 0x8218000
[pid  4955] open("/usr/lib/gconv/CP1251.so", O_RDONLY) = 10
[pid  4955] read(10,
"\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0\20\4\0"..., 512) = 512
[pid  4955] fstat64(10, {st_mode=S_IFREG|0644, st_size=9352, ...}) = 0
[pid  4955] mmap2(NULL, 12316, PROT_READ|PROT_EXEC, MAP_PRIVATE|MAP_DENYWRITE,
10, 0) = 0xb7577000
[pid  4955] mmap2(0xb7579000, 8192, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_FIXED|MAP_DENYWRITE, 10, 0x1) = 0xb7579000
[pid  4955] close(10)                   = 0
[pid  4955] brk(0)                      = 0x8218000
[pid  4955] brk(0x8240000)              = 0x8240000
[pid  4955] open("/usr/lib/gconv/KOI8-R.so", O_RDONLY) = 10
[pid  4955] read(10,
"\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0\20\4\0"..., 512) = 512
[pid  4955] fstat64(10, {st_mode=S_IFREG|0644, st_size=9352, ...}) = 0
[pid  4955] mmap2(NULL, 12316, PROT_READ|PROT_EXEC, MAP_PRIVATE|MAP_DENYWRITE,
10, 0) = 0xb7573000
[pid  4955] mmap2(0xb7575000, 8192, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_FIXED|MAP_DENYWRITE, 10, 0x1) = 0xb7575000
[pid  4955] close(10)                   = 0
[pid  4955] brk(0)                      = 0x8240000
[pid  4955] brk(0x8268000)              = 0x8268000
[pid  4955] open("/usr/lib/gconv/IBM866.so", O_RDONLY) = 10
[pid  4955] read(10,
"\177ELF\1\1\1\0\0\0\0\0\0\0\0\0\3\0\3\0\1\0\0\0\20\4\0"..., 512) = 512
[pid  4955] fstat64(10, {st_mode=S_IFREG|0644, st_size=9352, ...}) = 0
[pid  4955] mmap2(NULL, 12316, PROT_READ|PROT_EXEC, MAP_PRIVATE|MAP_DENYWRITE,
10, 0) = 0xb756f000
[pid  4955] mmap2(0xb7571000, 8192, PROT_READ|PROT_WRITE,
MAP_PRIVATE|MAP_FIXED|MAP_DENYWRITE, 10, 0x1) = 0xb7571000
[pid  4955] close(10)                   = 0
[pid  4955] brk(0)                      = 0x8268000
[pid  4955] brk(0x8289000)              = 0x8289000
[pid  4955] brk(0)                      = 0x8289000
[pid  4955] brk(0x82b1000)              = 0x82b1000
[pid  4955] --- SIGSEGV (Segmentation fault) @ 0 (0) ---
              = 0x8289000
[pid  4955] brk(0)                      = 0x8289000
[pid  4955] brk(0x82b1000)              = 0x82b1000
[pid  4955] --- SIGSEGV (Segmentation fault) @ 0 (0) ---
------- Comment #23 From 2005-04-19 19:07:19 -------
ben i need help
------- Comment #24 From 2005-04-19 19:09:29 -------
(In reply to comment #23)
> ben i need help

запускай под gdb и bt в студию. strace тут не помошник.
------- Comment #25 From 2005-04-19 19:21:48 -------
2 nikon, agent_007: sыложил на http://paq.osdn.org.ua/~mike/xmms-alt4/
srpm: http://paq.osdn.org.ua/~mike/xmms-alt4/xmms-1.2.10-alt4.src.rpm
------- Comment #26 From 2005-04-20 00:31:06 -------
Максимум что удалось получить, это:

Program received signal SIGSEGV, Segmentation fault.
[Switching to Thread 16384 (LWP 2228)]
0x40234ffb in xmms_convert_get_frequency_func () from /usr/lib/libxmms.so.1

Дальше gdb провешивает X'ы, и его приходится прибивать из консоли (параметр
--enable-debug так и не нашёл). Взрывается только если собирать с xmms-recode.
Запуск с различным LANG ни к чему не приводит. Единственный раз не взорвалось,
когда запустил 'LANG=ru_RU.UTF-8 xmms', и загрузил файлы .ogg с тэгами в UTF-8
(при .mp3 с тегами в koi8-r взрывается).
Вставка в xmms_convert_get_frequency_func() кучи printf() и перед вызовом этой
функции ни к чему не привела.
У кого больше экспы -- попробуйте разобраться.
------- Comment #27 From 2005-04-20 10:12:38 -------
гм. не могу повторить :) собраный с --build-args="--enable debug" xmms не 
падает ни при каких условиях. я уж как только не издевался над ним, и ~/.xmms 
сносил, и добавлял/удалял в плейлист всякое барахло, работает и всё тут.  

кто нибудь, соберите у себя и проверьте. 
------- Comment #28 From 2005-04-20 11:27:27 -------
Падение на xmms_convert_get_frequency_func() - это бред. В том смысле, что если
оно там падает, то это значит только что до этого "куча" попортилась. Михайло,
давай ты bt сюда.
------- Comment #29 From 2005-04-28 11:48:49 -------
*** Bug 6718 has been marked as a duplicate of this bug. ***
------- Comment #30 From 2005-04-30 13:58:55 -------
*** Bug 4295 has been marked as a duplicate of this bug. ***
------- Comment #31 From 2005-04-30 15:30:30 -------
В общем, пробуйте 1.2.10-alt4 сегодняшним числом.

Положил http://paq.osdn.org.ua/~mike/xmms-alt4/xmms-1.2.10-alt4.src.rpm и он же
в Sisyphus.

См. тж. #6752
------- Comment #32 From 2005-06-03 11:58:44 -------
Fixed in 1.2.10-alt5 with updated rusxmms-1.2.10-csa28 patch (thanks to Suren
Chilingaryan)